#include<stdio.h>
#include <string.h> 
#include <math.h> 
#include <stdlib.h>

#include <iostream>
#include <fstream>
#include <values.h>
#include <math.h>
#include <sstream>
#include <time.h>
#define float double
using namespace std;


#define nlin         31
#define c            0.05
#define E            0.1
#define Iconf        100
#define plasma       2.9693
#define cutoff       7
#define pi           3.141592654
#define Zeitmax      100000
#define nphase       40
#define neout        100
#define thermtime    3000

#define Kirkpatrick  iz = (iz + 1) % 250;  mz[iz] ^= mz[(iz+103) % 250];
#define outfile_x "Strom_3D_Lochdynamik_Coulomb_X0.0__%f_%f_%d"
/************************/
int          iz=1,mz[250],jzmax=2147483647,jz,a0=16807,np[500000];
const long   seed=372067;
double       norm,rnd,mu;
double       energy[nlin][nlin][nlin];
int          volume,lat[nlin][nlin][nlin],iconf;
int          npar,x_par[nlin*nlin*nlin],y_par[nlin*nlin*nlin],z_par[nlin*nlin*nlin];
double       current[Iconf][nphase+1],curfct[nphase+1],pot[nlin][nlin][nlin],f,totenergy,deltaenergy,thermenergy[neout],ion_sphere_radius,beta,energy_correction;
int          ranx,rany,ranz,i,j,k,hpar,ieout,ipar,totsteps,iestep,esteps,hlen,thermsteps;
int          dirx[6]={-1,1,0,0,0,0},diry[6]={0,0,-1,1,0,0},dirz[6]={0,0,0,0,-1,1};
/************************/
void  outputfile();void calpot(void);void thermalize(void);void metropolis_therm(int steps);void initialize(void);void site_energy(void);void pardis(void);
void rndNum(int seed) {norm=1.0/jzmax;int jz,jzmax=2147483647,a0=16807;jz=2*seed+1;for(i=0;i < 250;i++){jz *= a0; if(jz < 0) jz += jzmax +1; mz[i] = jz;}}
/************************/
int main() {

rand(time(NULL));calpot();

for(iconf=1;iconf<=Iconf;++iconf){

rndNum(seed); for(i=0;i<500000; i++){np[i]=0;}

site_energy();
pardis();
thermalize();
}
for(i=1;i<=nphase;i++){
for(iconf=1;iconf<=Iconf;++iconf){
curfct[i]+=current[iconf][i]/Iconf;}
//printf(" %f \t %f\n",Zeitmax*(double)i/nphase,curfct[i]);
}
outputfile();        
return 0;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void outputfile()
{
int l, t;
double iex, xfein=4.;
char name_x[300];
sprintf(name_x, outfile_x,c,beta,nlin);	
strcat(name_x, ".dat");// haengt Endung an name_x

FILE * outfile;
outfile = fopen(name_x, "w");
for(i=1;i<12;i++){
fprintf(outfile," %f \t %f\n",Zeitmax*(double)i/nphase,curfct[i]);
}
l=15;
for(i=12;i < nphase; i++){
iex = double(l)/xfein;
t = (int) pow(2.,iex);

if(i==t){
fprintf(outfile," %f \t %f\n",Zeitmax*(double)i/nphase,curfct[i]);
l++;}}
fclose(outfile);
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void     thermalize(void)
{
double   therm_step_interv;
int      ieout, iesteps;
         therm_step_interv=round(thermsteps/neout);
         esteps=10;
         thermsteps= thermtime*npar;
         
thermenergy[0]=0.0; totenergy=0.0;
for (i=0;i<npar;i++) 
for (j=i;j<npar;j++){ 
thermenergy[0]=thermenergy[0]+pot[abs(x_par[i]-x_par[j])][abs(y_par[i]-y_par[j])][abs(z_par[i]-z_par[j])]
                             +energy[x_par[i]][y_par[i]][z_par[i]];
                             totenergy=thermenergy[0];
}
                  

                 for (ieout=1;ieout<=neout;ieout++){                  /*(*1*)*/
                 metropolis_therm(therm_step_interv-esteps);
                  thermenergy[ieout]=0.0;
                  for (iestep=1;iestep<=esteps;iestep++){ /*(*2*)*/
                  metropolis_therm(1);
                  thermenergy[ieout]=thermenergy[ieout]+totenergy
                                                        /*(*2*)*/;}
                  thermenergy[ieout]=thermenergy[ieout]/esteps;         /*(*1*)*/}


                  FILE * outfile_thermalization;
                  outfile_thermalization = fopen("therm_coulomb.dat", "w");
                  for (ieout=1;ieout<=neout;ieout++){
                  fprintf(outfile_thermalization, "%d  %f\n",ieout,thermenergy[ieout]);

                                                    }
                  fclose(outfile_thermalization);
/* end of thermalize */}
//(******************************************************************************)
void   calpot(void){

int    lquad=nlin*nlin;
double gpara=pi/nlin,kconst=2*pi/nlin,
       aconst=pi*pi/(lquad*gpara*gpara),
       bconst=1/(pi*nlin),
       cconst=pi/(lquad*nlin*gpara*gpara),
       dconst=2*gpara/sqrt(pi);

int    dx,dy,dz;
double pota,potb,erfc,argerfc,distance,f,f1,f2,f3;
int    n1,n2,n3;
int    dquad,nquad,distquad;
       
for(dx=0;dx<nlin;++dx)
for(dy=0;dy<nlin;++dy)
for(dz=0;dz<nlin;++dz){/*1*/
dquad=dx*dx+dy*dy+dz*dz;
pota=0.0; potb=0.0;
for(n1=cutoff;n1>-1;--n1){/*2a*/   
f1=2*cos(kconst*n1*dx);
if(n1=0){f1=f1-1;}
for(n2=cutoff;n2>-1;--n2){/*3a*/        
f2=2*cos(kconst*n2*dy);
if(n2=0){ f2=f2-1;}
for(n3=cutoff;n3>0;--n3){/*4a*/  
f3=2*cos(kconst*n3*dz);
if(n3=0){ f3=f3-1;}
nquad=n1*n1+n2*n2+n3*n3;
if (nquad!=0){
pota=pota+f1*f2*f3*exp(-aconst*nquad)/nquad;}
}/*4a*/
}/*3a*/
}/*2a*/                            
pota=bconst*pota;
for(n1=-cutoff;n1<cutoff+1;++n1)
for(n2=-cutoff;n2<cutoff+1;++n2)
for(n3=-cutoff;n3<cutoff+1;++n3){ /*2b*/
nquad=n1*n1+n2*n2+n3*n3;
distquad=dquad+nquad*lquad-2*nlin*(n1*dx+n2*dy+n3*dz);
distance=sqrt(distquad);
argerfc=gpara*distance;
if ((nquad+distquad)!=0){ /*3b*/
f=1/(1+0.32759*argerfc);
erfc=f*(0.25482+f*(-0.28449+f*(1.42141+f*(-1.45315+f*1.06140))))*
                  exp(-(argerfc*argerfc));
potb=potb+erfc/distance;
}/*3b*/
}/*2b**/
pot[dx][dy][dz]=pota+potb-cconst;
                          
}/*1*/
pot[0][0][0]=pot[0][0][0]-dconst;

FILE * outfile_potcalc;
outfile_potcalc = fopen("pot_31.dat", "w");
for(dx=0;dx<nlin;++dx)
for(dy=0;dy<nlin;++dy)
for(dz=0;dz<nlin;++dz){ 
fprintf(outfile_potcalc, "%d %d %d  %f\n",dx,dy,dz,pot[dx][dy][dz]);
//printf("pot[%d][%d][%d] %f\n",dx,dy,dz,pot[dx][dy][dz]);
}
energy_correction=pot[0][0][0]-pot[0][0][1];
fclose(outfile_potcalc);
/* end of calpot */}
/************************/
void metropolis_therm(int steps)
{
int newx,newy,newz,oldx,oldy,oldz;
int ranpar,randir,ipar,random;
int iestep, esteps=10;
 int hdir=jzmax/6+1;
double transprob;
hpar=jzmax/(npar+1);

for (iestep=0;iestep<=steps;iestep++){

Kirkpatrick;ranpar=mz[iz]/hpar;
Kirkpatrick;randir=mz[iz]/hdir;

newx=x_par[ranpar]+dirx[randir];
newy=y_par[ranpar]+diry[randir];
newz=z_par[ranpar]+dirz[randir];

if(newx==nlin)                  newx=0;
else if(newx==-1)                 newx=nlin-1;
else if((newx<=nlin-1)&(newx>=0)) newx=x_par[ranpar]+dirx[randir];

if(newy==nlin)                  newy=0;
else if(newy==-1)                 newy=nlin-1;
else if((newy<=nlin-1)&(newy>=0)) newy=y_par[ranpar]+diry[randir];

if(newz==nlin)                  newz=0;
else if(newz==-1)                 newz=nlin-1;
else if((newz<=nlin-1)&(newz>=0)) newz=z_par[ranpar]+dirz[randir];


//printf("Das ausgewaehlte %d-te Teilchen kann zum [%d][%d][%d] \n",ranpar,newx,newy,newz);
if((lat[newx][newy][newz]==1)){/*4*/

oldx=x_par[ranpar];oldy=y_par[ranpar];oldz=z_par[ranpar];


//deltaenergy=energy[newx][newy][newz]-energy[oldx][oldy][oldz];
deltaenergy=0.0;
for (i=0;i<npar;i++)
deltaenergy=deltaenergy+pot[abs(x_par[i]-newx)][abs(y_par[i]-newy)][abs(z_par[i]-newz)]
                       -pot[abs(x_par[i]-newx)][abs(y_par[i]-newy)][abs(z_par[i]-newz)]
                       +energy[newx][newy][newz]
                       -energy[x_par[i]][y_par[i]][z_par[i]];
deltaenergy=deltaenergy+energy_correction;


               

           if(deltaenergy<=0){/*5a*/
           totenergy=totenergy+deltaenergy;
           x_par[ranpar]=newx;y_par[ranpar]=newy;z_par[ranpar]=newz;
           lat[oldx][oldy][oldz]=1;lat[newx][newy][newz]=0;/*5a*/
                           }

          else{/*5b*/
           Kirkpatrick;
           transprob=jzmax*exp(-beta*deltaenergy);
           if(mz[iz]<=transprob){/*6b*/
 
           x_par[ranpar]=newx;y_par[ranpar]=newy;z_par[ranpar]=newz;
           lat[oldx][oldy][oldz]=1;lat[newx][newy][newz]=0;
           /*6b,5b*/}}
          /*4*/}
}


}
//(******************************************************************************)
void initialize(void){
volume=nlin*nlin*nlin;    
npar=int(c*volume);printf("npar ist %d\n",npar);
ion_sphere_radius=pow(3.0/(4.0*pi*c),1/3.0);
beta=plasma*ion_sphere_radius;
printf("beta ist %f\n",beta);
for(i = 0;i<(nlin);i++) 
for(j = 0;j<(nlin);j++)                                                                                
for(k = 0;k<(nlin);k++){
lat[i][j][k]=1;energy[i][j][k]=0;}
/* end of initialize */}
//(******************************************************************************)
void   site_energy(void)
{
double*params=new double [(nlin)*(nlin)*(nlin)];
ifstream input;
input.open("Platzenergie_X_0.0.dat");
for(i=0;i<((nlin)*(nlin)*(nlin));i++){
input>>params[i];}
input.close();
for(i = 0;i<(nlin);i++)  
for(j = 0;j<(nlin);j++)
for(k = 0;k<(nlin);k++){
energy[i][j][k]=-1*params[nlin*nlin*i+nlin*j+k];}
/* end of site_energy */}
//(******************************************************************************)
void   pardis(void){
ipar=0;
while(ipar<npar){
ranx = rand() % (nlin);
rany = rand() % (nlin);
ranz = rand() % (nlin);

if(lat[ranx][rany][ranz]==1){
x_par[ipar]=ranx;
y_par[ipar]=rany;
z_par[ipar]=ranz;
lat[ranx][rany][ranz]=0;
//printf("Das %d-te Teilchen sitzt am [%d][%d][%d] \n",ipar,x_par[ipar],y_par[ipar],z_par[ipar]);
ipar++;}}
printf("Die Anzahl der Teilchen: %d\n",npar);
/* end of pardis */}
//(******************************************************************************)

