
//***********************************************************************************************
//cluster labeling algoritmus
//struc: enthaet zu labelnde cluserconfiguration
//lsp[][]: gelabelte clusterconfiguration
//np[]: enthaelt proper label
//ncluster: wird bei jedem neuen cluster um 1 erhoeht
//***********************************************************************************************
#include<stdio.h>
#include <stdlib.h> 
#include <string.h> 
#include <math.h> 


#define nlin 200
#define K  100
#define prop 0.65
//--------------------------------
//generator
int Jmult = 16807, Jiadd = 2147483647,iz=1,seed=372067,mz[250], lm,l_x,Jmz[nlin*nlin],Jitoz;
double norm,rnd,rnd1;
int label,h3,i,j, x, y,k;
//--------------------------------
//Global parameter von hilfreichen Gittern
int struc_help[nlin+1][nlin],struc_help1[nlin][nlin+1],lsp[nlin][nlin];
double struc[nlin][nlin],struc1[nlin][nlin];
//--------------------------------
//Global parameter von der gesuchenten Perkolationsschwelle
int summe1[K],summe2[K],summe[K],summe_c[K],summe_cl;
//--------------------------------
//Global parameter von dem gesuchenten unendlichen Cluster
int l,ll,lll,Hmax,Xmax,hhhh_x,hhhh_y,h_x,h_y,Hmax1,h[100];
double p[nlin*nlin],pp;
//--------------------------------
int np[500000];
void plot();
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void rndNum(int seed)  //Kirkpatrick Stall Generator1
{
int jz,jzmax=2147483647,a0=16807;
norm=1.0/jzmax;
jz=2*seed+1;
for(i=0;i < 250;i++){
jz *= a0;
if(jz < 0)
jz += jzmax +1;
mz[i] = jz;
}}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int intmax(int valuea,int valueb)//sucht den groesseren Label
{
if(valuea < valueb)
return valueb;
else 
return valuea;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int intmin(int valuea,int valueb)//sucht den kleineren Label
{
if(valuea < valueb)
return valuea;
else 
return valueb;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int proper( int label )//Hier wird der proper label gesucht
{
while( np[label -1] != 0 ){
label = np[label -1];}
return label;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int labelmin(int lw, int ls)//sind beide Nachbarn besetzt, sucht es den kleineren label von beiden.
{
int lmax=0 ,lmin=0; 
if( ls == lw ){return lw;}
else{lw = proper(lw); 
ls = proper(ls); 
lmax = intmax(lw,ls); 
lmin = intmin(lw,ls); 
if(lmax != lmin)//dem groesseren proper label wird der kleinere proper label zugeordnet
np[lmax-1] = lmin;return lmin;
  }
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int neighbours(int ls, int lw, int ss, int sw)//sucht die besetzten Nachbarn
{
int label;
if(sw * ss >0 ){        //der Fall, dass beide Nachbarn besetzt sind
label = labelmin(lw, ls);
return label;}
else if( ls >0 ){     //wenn nur ein Nachbar besetzt ist
label = ls;return label;}
else{       //dann kann es nur dieser sein
label = lw;return label;}
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int newcluster(int ncluster, int y, int x) //setzt neue Cluster um eins hoch
{
ncluster += 1; // neuer clusterlabel wird um eins hochgezaehlt
np[ncluster-1] = 0;//proper label ist hier noch 0
return ncluster;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void Hoshen_Kopelman_Algorithmus()//Berechnet die Clusterlabel
{
int ls, lw, ss, sw;
int ncluster = 0; 
int west=0,east=0,north=0,south=0;

ncluster = 0;  //der erste cluster mit den Koordinaten x=0, y=0
  if( struc[0][0]==-1.0 ){ 
  	ncluster = newcluster(ncluster, 0, 0); 
	lsp[0][0] = ncluster;    
  }

  for(x = 1; x <=(nlin/2);x++){
  	if( struc[0][2*x]==-1.0){
  		west = 2*x - 2;
  		if((struc[0][west]==-1.0 )&(struc_help[1][2*x-1]==1)){
  			lsp[0][2*x] = lsp[0][west]; 
		}
  		else {
  			ncluster = newcluster(ncluster, 0, x);
			lsp[0][2*x] = ncluster;
		}
  	}   
  }

  for(y=1; y<=(nlin/2);y++){
  	if(struc[2*y][0]==-1.0){
  		south = 2*y - 2;
  		if((struc[south][0]==-1.0)&(struc_help1[2*y-1][1]==1)){
  			lsp[2*y][0] = lsp[south][0];
		}
  		else{
  			ncluster = newcluster(ncluster,y, 0);
			lsp[2*y][0] = ncluster;
		}	
  	}
  	for(x = 1; x <=(nlin/2);x++){
		south = 2*y-2;
		west = 2*x-2;
  		if(struc[2*y][2*x]==-1.0){
  			if( struc[2*y][west] + struc[south][2*x]==0 ){
  				ncluster = newcluster( ncluster,2*y, 2*x);
				lsp[2*y][2*x] = ncluster;
			}
  			else{
                             if((struc_help[2*y+1][2*x-1]==0)&(struc_help1[2*y-1][2*x+1]==0)){
                              ncluster = newcluster( ncluster,y, x);
				lsp[2*y][2*x] = ncluster;} 


                                if((struc_help[2*y+1][2*x-1]==1)&(struc_help1[2*y-1][2*x+1]==0)){
                                          lsp[2*y][2*x] = lsp[2*y][west];

                                                                                              }
                               if((struc_help[2*y+1][2*x-1]==0)&(struc_help1[2*y-1][2*x+1]==1)){

                               lsp[2*y][2*x] = lsp[south][2*x];}


                                if((struc_help[2*y+1][2*x-1]==1)&(struc_help1[2*y-1][2*x+1]==1)){


				ls = lsp[south][2*x];
				lw = lsp[2*y][west]; 
                                ss =struc[south][2*x];
				sw = struc[2*y][west];
				lsp[2*y][2*x] = neighbours(ls, lw, ss, sw);

			}}
  		} 
  	} 
  }
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
void Gitter_Intialisierung()  
{
for(y = 0;y <=(nlin/2);y++){
for(x = 0;x <=(nlin/2); x++){
lsp[2*y][2*x]=0.0;}}
for(y = 0;y <=(nlin/2);y++){
for(x = 0;x <=(nlin/2); x++){
struc[2*y][2*x]=0.0;}}
for(y = 0;y <=(nlin/2);y++){
for(x = 0;x <=(nlin/2); x++){
struc1[2*y][2*x]=0.0;}}
for(y = 0;y <=(nlin/2);y++){
for(x = 0;x <(nlin/2) ;x++){
struc_help[2*y+1][2*x+1]=0;}}
for(y = 0;y <(nlin/2);y++){
for(x = 0;x <=(nlin/2);x++){
struc_help1[2*y+1][2*x+1]=0;}}
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
int main() //hauptfunktion
{

for(k=0;k<K;k++){  
summe_c[k]=0;}
for(k=0;k<K;k++){  
seed=372067+2*k;
rndNum(seed);
for(i=0;i<500000; i++){
np[i]=0;}
//---------------------------------------
Gitter_Intialisierung();
//---------------------------------------
for(y = 0;y<=(nlin/2);y++){                                                                                 
for(x = 0;x<(nlin/2);x++){
iz = (iz + 1) % 250;
mz[iz] ^= mz[(iz+103) % 250];
rnd = mz[iz]*norm;//printf(" rnd ist %f\n", rnd);
if(rnd < prop){
struc[2*y][2*x]=struc[2*y][2*x+2]=-1;
struc_help[2*y+1][2*x+1]=1;}
//printf(" struc_help[%d][%d] ist %d\n", 2*y+1,2*x+1,struc_help[2*y+1][2*x+1]);	
}}

for(y = 0;y<(nlin/2);y++){                                                                                 
for(x = 0;x<=(nlin/2);x++){
iz = (iz + 1) % 250;
mz[iz] ^= mz[(iz+103) % 250];
rnd1 = mz[iz]*norm;//printf(" rnd1 ist %f\n", rnd1);	
if((rnd1 < prop))
{
struc[2*y][2*x]=struc[2*y+2][2*x]=-1;
struc_help1[2*y+1][2*x+1]=1;}
//printf(" struc_help1[%d][%d] ist %d\n", 2*y+1,2*x+1,struc_help1[2*y+1][2*x+1]);	
}}
//-----------------------------------------
for(y = 0;y <=(nlin/2);y++){
for(x = 0;x <=(nlin/2); x++){
//printf(" struc[%d][%d] ist %f\n", 2*y,2*x,struc[2*y][2*x]);	
}}     
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
Hoshen_Kopelman_Algorithmus(); 
for(y = 0;y<=(nlin/2);y++){// speichert an der stelle des gefundenen Labels den proper Label ab.
for(x = 0;x<=(nlin/2);x++){
label = lsp[2*y][2*x];
if(label > 0){
label = proper(label);
lsp[2*y][2*x] = label;
}}}
for(y = 0;y <=(nlin/2);y++){
for(x = 0;x <=(nlin/2);x++){
//printf(" lsp[%d][%d] ist %d\n", 2*y,2*x,lsp[2*y][2*x]);    
}}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx Bestimmung der Konzentration xxxxxx
summe1[k]=0;
for(y = 0;y<=(nlin/2);y++){                      
for(x = 0;x<(nlin/2);x++){
summe1[k]+=struc_help[2*y+1][2*x+1];    
}}
//printf(" summe1 ist %d\n", summe1[k]);
summe2[k]=0;
for(y = 0;y<(nlin/2);y++){                      
for(x = 0;x<=(nlin/2);x++){
summe2[k]+=struc_help1[2*y+1][2*x+1];
}}
//printf(" summe2 ist %d\n", summe2[k]); 
summe[k]=0;
summe[k]=summe1[k]+summe2[k];
//printf(" summe ist %d\n", summe[k]);
p[k]=summe[k]/(double)(2*((nlin/2)+1)*(nlin/2));
//printf(" die Bindungskonzentration ist %f\n", p[k]);    
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
Xmax=1;
for(y = 0;y <=(nlin/2);y++){
for(x = 0;x <=(nlin/2);x++){
if(lsp[2*y][2*x]>Xmax){Xmax=lsp[2*y][2*x];}
}}
for(l = 1;l<=Xmax ;l++){
h[l]=0;}
for(l = 1;l<=Xmax ;l++){
for(y = 0;y <=(nlin/2);y++){
for(x = 0;x <=(nlin/2);x++){
if(lsp[2*y][2*x]==l){h[l]= h[l]+1;}}}}
Hmax=0;
for(l = 1;l<=Xmax ;l++){
if(h[l]>Hmax){Hmax=h[l];}}
Hmax1=0;
for(l = 1;l<=Xmax ;l++){
if((h[l]>Hmax1)&&(h[l]!=Hmax)){Hmax1=h[l];}}
for(i = 1;i<=Xmax ;i++){
if(h[i]==Hmax)
ll=i;}
for(j = 1;j<=Xmax ;j++){
if(h[j]==Hmax1)
lll=j;}
//xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx Unendlicher Cluster wird gesuchtxxxxxxxxx
hhhh_x=0;
for(y = 0;y <=(nlin/2);y++){
for(x = 0;x <=(nlin/2);x++){
if((lsp[0][2*y]==ll)&&(lsp[nlin][2*x]==ll)){hhhh_x+=1;}
}}
if(hhhh_x!=0){/*printf("Der Label des unendlichen Clusters ist links,rechts: %d\n",ll);*/h_x+=1;summe_c[k]+=1;}
else if(hhhh_x==0){/*printf("Es gibt keinen unendlichen Cluster links,rechts\n");*/}
hhhh_y=0;
for(y = 0;y <=(nlin/2);y++){
for(x = 0;x <=(nlin/2);x++){
if((lsp[2*y][0]==ll)&&(lsp[2*x][nlin]==ll)){hhhh_y+=1;}}}
if(hhhh_y!=0){/*printf("Der Label des unendlichen Clusters  ist oben,unten:" "%d\n",ll);*/h_y+=1;summe_c[k]+=1;}
else if(hhhh_y==0){/*printf("Es gibt keinen unendlichen Cluster oben,unten\n");*/}
}
for(k=0;k<K;k++){  
summe_cl+=summe_c[k];
pp+=p[k];
}
printf(" die Anzahl der unendlichen Cluster bei 100 Konfigurationen ist %d\n", summe_cl);
//printf(" die mittelte Perkolationsschwelle ist %f\n", double(pp/K));  


return 0;
}
//XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


